var canvas;
var ctx;
var keys = new Array(6);
var buffer = new Array(12);

var green = {r:0,g:255,b:0};
var red = {r:255,g:0,b:0};
var blue = {r:0,g:0,b:255};
var white = {r:255,g:255,b:255};
var yellow = {r:255,g:215,b:0};
var black = {r:0,g:0,b:0};

var onhomescreen;
var buttontrophy;

var topcolor;//generated color
var bottomcolor;//your color
var time;//time till colors are checked

var armed;
var canbearmed;
var armtogglewait;//how long before arming
var disarmtogglewait;//see above just flipped
var armtimer;

var mask;//what colors to draw/are broken
var room;//room for error when checking colors
var result;//if you won or lost
var levelpointer;//current level

var levels =[{time:2550,mask:[0,0,0,0,0,0,0,0,0,0,0,0],lvlroom:50,canarm:0,await:0,dwait:0},
    {time:2550,mask:[0,0,0,1,0,0,0,1,0,0,0,0],lvlroom:50,canarm:0,await:0,dwait:0},
    {time:2550,mask:[1,0,0,0,0,0,0,0,0,0,0,0],lvlroom:50,canarm:0,await:0,dwait:0},
    {time:2550,mask:[1,1,0,0,0,0,0,0,0,0,0,0],lvlroom:50,canarm:0,await:0,dwait:0},
    {time:2550,mask:[1,1,1,0,0,0,0,0,0,0,0,0],lvlroom:50,canarm:0,await:0,dwait:0},
    {time:2550,mask:[1,1,1,0,1,0,0,0,0,0,0,0],lvlroom:50,canarm:0,await:0,dwait:0},
    {time:1500,mask:[1,1,1,0,1,1,1,0,0,0,0,0],lvlroom:50,canarm:0,await:0,dwait:0},
    {time:1500,mask:[0,1,0,0,1,0,1,0,0,0,0,0],lvlroom:25,canarm:1,await:500,dwait:100},
    {time:1500,mask:[0,0,0,1,0,0,0,1,0,0,0,0],lvlroom:25,canarm:1,await:400,dwait:100},
    {time:1500,mask:[0,0,0,1,1,1,1,0,0,0,0,0],lvlroom:25,canarm:1,await:500,dwait:100}];

function relativeequal(pram1,pram2){
    if(pram1<pram2+room&&pram1>pram2-room)return true;
    return false;
}

function fill(pram){
    var ct;
    for(ct=0;ct<12;ct++){
        buffer[ct]=pram;
    }
    refresh();
}

function lose(){
    fill(red);
    levelpointer=0;
    onhomescreen=true;
    setTimeout(startandanimate,2000)
}

function win(){
    fill(green);
    levelpointer++;
    if(levelpointer<levels.length)setTimeout(newlevel,1000);
    else {
        fill(yellow);
        buttontrophy=1;
        setTimeout(startgame,5000);
    }
}
function randomcolor(){
    var newcolor = {r:0,g:0,b:0};
    newcolor.r = (Math.random()*10000)%255;
    newcolor.g = (Math.random()*10000)%255;
    newcolor.b = (Math.random()*10000)%255;
    return newcolor;
}


function newlevel(){
    topcolor = randomcolor();
    bottomcolor = randomcolor();
    time = levels[levelpointer].time;
    mask = levels[levelpointer].mask;
    room = levels[levelpointer].lvlroom;
    canbearmed = levels[levelpointer].canarm;
    disarmtogglewait = levels[levelpointer].dwait;
    armtogglewait = levels[levelpointer].await;
    armed = 0;
    armtimer = armtogglewait;
    loop();
}

function processresult(){
    if(relativeequal(topcolor.r,bottomcolor.r)&&relativeequal(topcolor.g,bottomcolor.g)&&relativeequal(topcolor.b,bottomcolor.b))win();
    else lose();
}

function controls(){
    if(keys[0]&&bottomcolor.r<255)bottomcolor.r++;
    if(keys[1]&&bottomcolor.g<255)bottomcolor.g++;
    if(keys[2]&&bottomcolor.b<255)bottomcolor.b++;
    if(keys[3]&&bottomcolor.r>0)bottomcolor.r--;
    if(keys[4]&&bottomcolor.g>0)bottomcolor.g--;
    if(keys[5]&&bottomcolor.b>0)bottomcolor.b--;
}

function processarm(){
    armtimer--;
    if(armed){
        setpixel(2,2,red);
        setpixel(3,2,red);
        if(armtimer<1){
            armed=0;
            armtimer=armtogglewait;
        }
    }
    else if(armtimer<200&&!armed){
        setpixel(2,2,yellow);
        setpixel(3,2,yellow);
        if(armtimer<1){
            armed=1;
            armtimer=disarmtogglewait;
        }
    }
    else {
        setpixel(2,2,green);
        setpixel(3,2,green);
    }
}

function loop(){
    controls();
    setsubpixel(0,0,1,topcolor.r);
    setsubpixel(1,0,2,topcolor.g);
    setsubpixel(2,0,3,topcolor.b);
    setsubpixel(0,1,1,bottomcolor.r);
    setsubpixel(1,1,2,bottomcolor.g);
    setsubpixel(2,1,3,bottomcolor.b);
    setpixel(3,0,topcolor);
    setpixel(3,1,bottomcolor);
    var timercolor = {r:time/10,g:time/10,b:time/10};
    setpixel(0,2,timercolor);
    setpixel(1,2,timercolor);
    if(canbearmed)processarm();
    if(armed&&anykeypressed()){
        setTimeout(lose,0);
        return;
    }
    time--;
    refresh();
    if(time>0)setTimeout(loop,1);
    else processresult();
}

function getsmallest(in1,in2){
    if(in2<in1)return in2;
    else return in1;
}

function resizegame(){
    var size = getsmallest(window.innerWidth,window.innerHeight);
    canvas.width = size;
    canvas.height = size;
    ctx.scale(size/4,size/4);
}

function pushcontrol(key){
    var button = key.keyCode;
    switch(button){
        case 81://q
            keys[0]=true;
            break;
        case 87://w
            keys[1]=true;
            break;
        case 69://e
            keys[2]=true;
            break;
        case 65://a
            keys[3]=true;
            break;
        case 83://s
            keys[4]=true;
            break;
        case 68://d
            keys[5]=true;
            break;
    }
    
}

function releasecontrol(key){
    var button = key.keyCode;
    switch(button){
        case 81://q
            keys[0]=false;
            break;
        case 87://w
            keys[1]=false;
            break;
        case 69://e
            keys[2]=false;
            break;
        case 65://a
            keys[3]=false;
            break;
        case 83://s
            keys[4]=false;
            break;
        case 68://d
            keys[5]=false;
            break;
    }
}

function setsubpixel(x,y,sub,color){
    var temp = {r:0,g:0,b:0};
    switch(sub){
        case 1:
            temp.r=color
            break;
        case 2:
            temp.g=color
            break;
        case 3:
            temp.b=color
            break;
    }
    setpixel(x,y,temp);
}

function brokenpixel(current){
    if(current==black)return white;
    else return black;
}

function setpixel(x,y,color){
    if(mask[y*4+x]==0)buffer[y*4+x]=color;
    else buffer[y*4+x]=brokenpixel(buffer[y*4+x]);
}

function setpixelnomask(x,y,color){
    buffer[y*4+x]=color;
}

function colortohtml(input){
    return "rgb("+Math.floor(input.r)+","+Math.floor(input.g)+","+Math.floor(input.b)+")";
}

function cdf(x,y,color){//consolidated drawing function/end of the line for virtual lcd access
    ctx.fillStyle=colortohtml(color);
    ctx.fillRect(Math.floor(x),Math.floor(y),1,1);
}

function refresh(){
    var meep;
    for(meep=0;meep<12;meep++){//4*3=12
        cdf(meep%4,meep/4,buffer[meep])
    }
}

function anykeypressed(){
    var check;
    for(check=0;check<6;check++){
        if(keys[check]==true)return true;
    }
    return false;
}

function startandanimate(){
    setTimeout(animatetitle,0);
    setTimeout(startgame,0);
}


function animatetitle(){
    if(!onhomescreen)return;
    var tiles;
    for(tiles=0;tiles<8;tiles++){
        buffer[tiles]=randomcolor();
    }
    for(;tiles<12;tiles++){
        if(buttontrophy!=0)buffer[tiles]=yellow;
        else buffer[tiles]=green;
    }
    refresh();
    setTimeout(animatetitle,500);
}

function startgame(){
    if(anykeypressed()){
        onhomescreen=false;
        levelpointer=0;
        newlevel();
    }
    else setTimeout(startgame,10);
}

function main(){
    buttontrophy=0;
    canvas = document.getElementById("display");
    ctx = canvas.getContext("2d");
    window.addEventListener('resize', resizegame, false);
    window.addEventListener("keydown", pushcontrol, false);
    window.addEventListener("keyup", releasecontrol, false);
    onhomescreen=true;
    resizegame();
    startandanimate();
}